<?php
namespace Pinpoint\RedirectManager\Controller\Adminhtml\Redirects;

use Magento\Backend\App\Action;

/**
 * Class Delete
 * @package Pinpoint\RedirectManager\Controller\Adminhtml\Redirects
 */
class Delete extends \Magento\Backend\App\Action
{
    /**
     * @var string
     */
    const ADMIN_RESOURCE = 'Pinpoint_RedirectManager::redirectAdd';

    /**
     * @var \Pinpoint\RedirectManager\Model\ResourceModel\Redirect\Collection
     */
    protected $redirectCollection;

    /**
     * Delete constructor.
     * @param Action\Context $context
     * @param \Pinpoint\RedirectManager\Model\ResourceModel\Redirect\Collection $redirectCollection
     */
    public function __construct(
        Action\Context $context,
        \Pinpoint\RedirectManager\Model\ResourceModel\Redirect\Collection $redirectCollection
    ) {
        $this->redirectCollection = $redirectCollection;
        parent::__construct($context);
    }

    /**
     * @return $this
     */
    public function execute()
    {
        // check if we know what should be deleted
        $id = $this->getRequest()->getParam('id');
        /** @var \Magento\Backend\Model\View\Result\Redirect $resultRedirect */
        $resultRedirect = $this->resultRedirectFactory->create();
        if ($id) {
            $title = "";
            try {
                // init model and delete
                $model = $this->redirectCollection;
                $model->load($id);
                $model->delete();
                // display success message
                $this->messageManager->addSuccess(__('You have deleted the redirect.'));
                // go to grid
                return $resultRedirect->setPath('*/*/');
            } catch (\Exception $e) {
                // display error message
                $this->messageManager->addError($e->getMessage());
                // go back to edit form
                return $resultRedirect->setPath('*/*/edit', ['id' => $id]);
            }
        }
        // display error message
        $this->messageManager->addError(__('We can not find a redurect to delete.'));
        // go to grid
        return $resultRedirect->setPath('*/*/');
        
    }    
    
}
