<?php

namespace Pinpoint\RedirectManager\Controller\Adminhtml\Redirects;

use Magento\Backend\App\Action;
use Magento\Backend\App\Action\Context;
use Magento\Framework\App\Filesystem\DirectoryList;

class DownloadCsv extends Action
{
    protected $redirect;

    public function __construct(
        Context $context,
        \Pinpoint\RedirectManager\Model\Redirect $redirect
    ) {
        $this->redirect = $redirect;
        parent::__construct($context);
    }

    public function execute()
    {
        $redirects = $this->redirect;
        $request = $this->getRequest();

        $collection = $redirects->getCollection();

        if (is_array($request->getParam('excluded')) && $excluded = $request->getParam('excluded')) {
            $collection->addFieldToFilter('id', ['nin' => array_values($excluded)]);
        }

        if (is_array($request->getParam('selected')) && $selected = $request->getParam('selected')) {
            $collection->addFieldToFilter('id', ['in' => array_values($selected)]);
        }

        if (is_array($request->getParam('filters'))) {
            $filters = $request->getParam('filters');
            unset($filters['placeholder']);
            foreach ($filters as $field => $filter) {
                $collection->addFieldToFilter($field, $filter);
            }
        }

        $fileName = 'redirects-export.csv';
        header("Content-type: text/csv");
        header("Content-Disposition: attachment; filename=" . $fileName);
        header("Pragma: no-cache");
        header("Expires: 0");

        $output = "";
        $i = 0;
        foreach ($collection->getItems() as $redirect) {
            if (!$i) {
                $output .= implode(",", array_keys($redirect->getData())) . PHP_EOL;
            }
            $output .= implode(",", $redirect->getData()) . PHP_EOL;
            $i++;
        }
        
        echo $output;
        exit;
    }
}
