<?php

namespace Pinpoint\RedirectManager\Controller\Adminhtml\Redirects;

use Magento\Backend\App\Action;
use Magento\Backend\App\Action\Context;

/**
 * Class UploadCsv
 * @package Pinpoint\RedirectManager\Controller\Adminhtml\Redirects
 */
class UploadCsv extends Action
{
    /**
     * @var \Pinpoint\RedirectManager\Model\Redirect
     */
    protected $redirect;

    /**
     * UploadCsv constructor.
     * @param Context $context
     * @param \Pinpoint\RedirectManager\Model\Redirect $redirect
     */
    public function __construct(
        Context $context,
        \Pinpoint\RedirectManager\Model\Redirect $redirect
    ) {
        $this->redirect = $redirect;
        parent::__construct($context);
    }

    /**
     * @return \Magento\Framework\App\ResponseInterface
     */
    public function execute()
    {
        $rows = 0;
        if ($csvFile = $this->getRequest()->getFiles('csv_file')) {
            if (($handle = fopen($csvFile["tmp_name"], "r")) !== FALSE) {
                while (($data = fgetcsv($handle, 1000, ",")) !== FALSE) {
                    $num = count($data);
                    if ($num == 3) {
                        $redirect = $this->redirect;

                        $redirect->setData([
                            'requested_path' => $data[0],
                            'target_path' => $data[1],
                            'redirect_type' => $data[2]
                        ])->save();
                        $rows++;
                    }
                }
                fclose($handle);
            }
        }

        $this->messageManager->addSuccess(__('Imported %1 redirects.', $rows));
        return $this->_redirect('*/*/index');
    }
}
